function newShip() {
	var o = new Object();
	o.addModule = addModule;
	o.getHTML = getHTML;
	o.minRow = 0;
	o.maxRow = -1;
	o.minCol = 0;
	o.maxCol = -1;
	return o;
}

var moduleNames = new Array('can','lif','sci',
	'hel','car','hul','hyp','mis','tel','tra',
	'eng','sic','dam', 'fig', 'min','7d','7r',
	'clo','fus','gra');

var moduleFiles = new Array('cannon', 'life_support', 'science', 'helm',
	'cargo_bay', 'hull_stabilizer', 'hyperdrive', 'missile_bay',
	'teleporter', 'tractor', 'engine', 'sick_bay', 'damage_control',
	'fighter_bay', 'mine_layer', '7down', '7right',
	'cloaking_device','fusion_cannon','gravity_lance');

function addModule(type, col, row, face) {
	if(face > -4 && face < 4) {
		if(face < 0) face = 4+face;
		face *= 90;
	}
	else if(face < 0) {
		face = 360 - face;
	}

	if(face == 0 || face == 90 || face == 180 || face == 270)
	{
		var o = new Object();
		o.col = col;
		o.row = row;
		o.type = type;
		o.face = (face == 0 ? '' : '-' + face);
		// update min and max row
		if(row < this.minRow) this.minRow = row;
		if(row > this.maxRow) this.maxRow = row;
		if(col < this.minCol) this.minCol = col;
		if(col > this.maxCol) this.maxCol = col;

		// insert sorted by columns
		if(!this.modList || this.modList.col >= o.col)
		{
			o.next = this.modList;
			this.modList = o;
		}
		else {
			var cur, next;
			for(cur = this.modList; cur.next; cur = cur.next) {
				if(cur.next.col >= col) {
					o.next = cur.next;
					cur.next = o;
					break;
				}
			}
			if(!cur.next) {
				cur.next = o;
			}
		}
	}
}

function getHTML(imgSize) {
	if(!this.modList || this.maxRow < this.minRow) {
		return '[no ship]';
	}
	var html = '<table border=0 cellpadding=0 cellspacing=0>';
	var row, lastCol, mod;
	for(row = this.minRow; row <= this.maxRow; row++) {
		html += '<tr>';
		var lastCol = this.minCol;
		for(mod = this.modList; mod; mod = mod.next) {
			if(mod.row != row)
				continue;
			while(lastCol++ < mod.col) {
				html += '<td>&nbsp</td>';
			}

			var modName = '';
			for(var i=0; i<moduleNames.length; i++) {
				if(moduleNames[i] == mod.type.toLowerCase()) {
					modName = moduleFiles[i];
					break;
				}
			}
			if(!modName) modName = mod.type;
			modName += mod.face;


			html += '<td><img src="img/' + modName + '.jpg" ' +
				'height='+imgSize+' width='+imgSize+'/></td>';
		}

		while(lastCol++ <= this.maxCol) {
			html += '<td>&nbsp;</td>';
		}

		html += '</tr>';
	}

	html += '</table>';
			
	return html;	
}

function makeShip() {
	var o = newShip();
	for(var i=1; i<arguments.length; i+=4) {
		o.addModule(arguments[i], arguments[i+1], arguments[i+2],arguments[i+3]);
	}
	document.write(o.getHTML(arguments[0]));
}
